; Super Punch-Out!!
; Date: 2019.08.16
;
; Changelog:
;	- (2019.08.16) added spc fallback, hopefully it is good, PeV
;	- (2019.08.16) added LDX #$22 and TXA before JSL msuRoutine so correct track values write to STA $2004


lorom

org $01EC6d ; do msu1 and mutes the game
JSL msu


org $08cc0b
JSL mutedemo

org $408000
msu:
PHA
TXA
PHP ;save processor status
SEP #$20
lda $2002
CMP #$53
BEQ msufound
PLP ;restore processor status
PLA ;native code if no msu
LDX $22
CPX $39
RTL

msufound:
PLP ;restore processor status
PLA ;get track number from stack

PHA
PHP ;save processor status again
SEP #$20
LDX $22 ; <----- i moved this here to get msu-1 to play correctly, PeV
TXA ; <----- i moved this here to get msu-1 to play correctly, PeV
STZ $2006
STA $2004
STZ $2005
loop:
BIT $2000
BVS loop
PHA
; -- PCM PRESENT CHECK, FOR SPC FALLBACK --
	LDA $2000 ; load msu status register value to check if track is present or missing
	AND #$08 ; isolate track missing bit
	BNE spcFallback ; if not, play SPC instead
; -- PCM PRESENT CHECK, FOR SPC FALLBACK --
PLA
cmp #$61
BEQ noloop
cmp #$62
BEQ noloop
cmp #$6C
BEQ noloop
cmp #$71
BEQ noloop
cmp #$70
BEQ noloop
LDA #$03
BRA endroutine
noloop:
LDA #$01
endroutine:
STA $2007
LDA #$FF
STA $2006

PLP ;restore processor status
PLA
LDX #$00
CPX $39
RTL

spcFallback:
PLA
PLP
PLA
LDX $22
CPX $39
RTL



mutedemo:
JSL $01f800
PHA
CMP #$00
STZ $2007
PLA
RTL

;------------------------------------------
;org $01EC75
;db $2F

;org $01F174 ;full mute
;STZ $24;20

;org $01ECF8 ;do msu1 with values correctly..but it dont mute
